//+------------------------------------------------------------------+
//|															geExtrapolatorBuff.mq4		|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
#define		IndicatorName "geExtrapolatorBuff"

#property indicator_chart_window
//#property indicator_separate_window
//#property indicator_minimum -1.5
//#property indicator_maximum 1.5
#property indicator_buffers 3
#property indicator_color1 Turquoise//CadetBlue
#property indicator_color2 Coral//GreenYellow
#property indicator_color3 Yellow//GreenYellow

//---- input parameters
extern int		Present			= 300;
extern int		ForeCast			= 14;
extern int		HarmCount		= 21;
//extern double  FreqTOL  		=	0.0001;//Tolerance of frequency calculation for Method 1
extern int		Shift				= 0;													// -->
extern int		OffSet			= 0;
extern int		Counter			= 1000;

//+------------------------------------------------------------+
//+                       					+
//+------------------------------------------------------------+
double	FxView1[];
double	FxView2[];
double	FxView3[];
double	FxView4[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Work Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int 		Ix;
int 		Sx;
datetime	TimeSave;
double	StaticBuf[];

double	Rates[];
double	TimeBuf1[];
double	TimeBuf2[];
double	TimeBuf3[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Initialization program Buffers ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	InitBufferam(int iBufferSize)
{
	ArrayResize(Rates,iBufferSize);
	ArrayResize(TimeBuf1,iBufferSize);
	ArrayResize(TimeBuf2,iBufferSize);
	ArrayResize(TimeBuf3,iBufferSize);
	//-->
	ArrayResize(StaticBuf,iBufferSize);
	ArrayInitialize(StaticBuf,NULL);
	return;
}
void	EmptyBufferam()
{
	ArrayInitialize(Rates,EMPTY_VALUE);
	ArrayInitialize(TimeBuf1,EMPTY_VALUE);
	ArrayInitialize(TimeBuf2,EMPTY_VALUE);
	ArrayInitialize(TimeBuf3,EMPTY_VALUE);
// -->
	InitChart(FxView1);														// -->
	InitChart(FxView2);														// -->
	InitChart(FxView3);														// -->
	InitChart(FxView4);														// -->
	return;
}
void	DoneBufferam()
{
	ArrayResize(Rates,0);
	ArrayResize(TimeBuf1,0);
	ArrayResize(TimeBuf2,0);
	ArrayResize(TimeBuf3,0);
	//---------------------------------
	ArrayResize(StaticBuf,0);
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Program Constants ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int		MaxPeriod=0;
int		CalcCount=0;
//---------------------------   ------------------
#include "ge_Extrapolator.mq4"
#include "ge_TicketCtrl.mq4"													// -->
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
  {
//---- initialization program values  --------------------------------
	MaxPeriod=MathMax(Present,Present);//MathMax(ShortPrd,MathMax(SlowPrd,LongPrd)));
	InitBufferam(MaxCounter(Counter,MaxPeriod));
	CalcCount=InitCounter(Counter,MaxPeriod);
	TimeSave=0;									// Ticket  ,     
//---- initialization indicators -------------------------------------
	SetupChartLine(0,FxView1,0,2,"LagMA"+Present);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(1,FxView2,0,2,"LagMA"+Present);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(2,FxView3,0,2,"LagMA"+Present);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
   IndicatorShortName(IndicatorName+"("+Present+")");
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	//SetIndexShift(0,-FuturePrd);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(1,ForeCast);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb

	InitTicket(StringSubstr(IndicatorName,2,StringLen(IndicatorName)-2));					// -->
	TimeSave=Time[Counter];
	Print("Init :",TimeToStr(TimeSave,TIME_DATE|TIME_MINUTES));
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator deinitialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
	DoneBufferam();	
	DoneTicket();																					// -->
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Start defination ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{
//	if (StartCalculate(Shift)==false)											// -->
	if (StartTicket(Shift)==false)											// -->
	{																					// -->
		if (!StartCounter(IndicatorName,Counter,CalcCount,MaxPeriod)) return(-1);
	}																					// -->
	else {																			// -->
		if (cwCalculated==true) return(0);									// -->
	}																					// -->
//------------------------------------------------------------------------------------
	EmptyBufferam();
//+-------------------------- Begin Cycle ---------------------------------------------------+\\
	ReadValueTicket(Shift,Ix);											// -->
	
	datetime TimeCalc=Time[0];
	//Print("Prev :",TimeToStr(TimeSave,TIME_DATE|TIME_MINUTES),"  Next :",TimeToStr(TimeCalc,TIME_DATE|TIME_MINUTES));
	int TimeCount=iBarShift(NULL,0,TimeSave)-iBarShift(NULL,0,TimeCalc);
	//Print(" Count : ",TimeCount);
	//  
	if (TimeCount>0){
		CopySeries(Rates,MODE_CLOSE,Period(),Shift+TimeCount);	
		for (Ix=Counter-1;Ix>=TimeCount;Ix--){
			StaticBuf[Ix+1]=StaticBuf[Ix];
		}
		for (Ix=TimeCount;Ix>0;Ix--){
			CopySeries(Rates,MODE_CLOSE,Period(),Shift+Ix);	
   		Extrapolator(Rates,TimeBuf1,Present,TimeBuf2,1,HarmCount,Shift);
			StaticBuf[Ix]=TimeBuf1[0];
		}
	}
	CopySeries(Rates,MODE_CLOSE,Period(),Shift);	
  	Extrapolator(Rates,TimeBuf1,Present,TimeBuf2,ForeCast,HarmCount,Shift);
	StaticBuf[0]=TimeBuf1[0];
  	TimeBuf2[ForeCast]=TimeBuf1[0];
  	ArrayCopy(FxView1,TimeBuf1,Shift,0,Present);
  	ArrayCopy(FxView2,TimeBuf2,Shift,0,ForeCast+1);
  	ArrayCopy(FxView3,StaticBuf,Shift,0,CalcCount);
  	TimeSave=TimeCalc;
  	
	CalculateFinishedTicket();													// -->

//----
   return(0);
  }

//--------------------------------------------------------------------
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 InitCounter																		~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 int InitCounter(int iPreCount,int iMaxPeriod)
{
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	int Result=MaxCounter(iPreCount,iMaxPeriod);
	// Rule 2
	if ((Result+iMaxPeriod)>Bars) Result=Bars-iMaxPeriod;
	// Rule 3
	if (Result<iMaxPeriod) Result=0;
	else Result=Result+iMaxPeriod;
	return(Result);
}
//------------------------------------------ StartCounter --------------------------
bool StartCounter(string WindowName,int iPreCount,int& iCalcCount,int iMaxPeriod)
{
	if ((iPreCount>iCalcCount)||(iPreCount==0)) iCalcCount=InitCounter(iPreCount,iMaxPeriod);
	if (iCalcCount==0) 
	{
		Alert(WindowName+" "+Symbol()+"("+Period()+") - Limited Calculate Period");
		return(false);
	}
	return(true);
	//int iBarCount=IndicatorCounted();
	//if (iBarCount>0) return(true);
	//Print("StartCounter");
	return(false);
}
//------------------------------------------ StartCounter --------------------------
int MaxCounter(int iPreCount,int iMaxPeriod)
{
	int Result=iPreCount;
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	if (Result==0) Result=Bars-1;
	if (Result<iMaxPeriod) Result=iMaxPeriod;
	return(Result+iMaxPeriod);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 Style active Line																~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetupChartLine(int Index,double& ViewAy[],int Style,int Width,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																CopySeries																	~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CopySeries(double& CopyRate[],int SeriesIndex,int TimeFrame,int iShift)
{
/*
	MODE_OPEN 0   	
	MODE_LOW 1   
	MODE_HIGH 2   
	MODE_CLOSE 3   
	MODE_VOLUME 4  ( ,  ) 
	MODE_TIME 5    
*/
	for (int Cx=0;Cx<ArraySize(CopyRate);Cx++)
	{
		switch (SeriesIndex)
		{
		case MODE_OPEN 	: CopyRate[Cx]=iOpen(NULL,TimeFrame,Cx+iShift);break;
		case MODE_LOW 		: CopyRate[Cx]=iLow(NULL,TimeFrame,Cx+iShift);break;
		case MODE_HIGH 	: CopyRate[Cx]=iHigh(NULL,TimeFrame,Cx+iShift);break;
		case MODE_CLOSE 	: CopyRate[Cx]=iClose(NULL,TimeFrame,Cx+iShift);break;
		case MODE_VOLUME 	: CopyRate[Cx]=iVolume(NULL,TimeFrame,Cx+iShift);break;
		case MODE_TIME 	: CopyRate[Cx]=iTime(NULL,TimeFrame,Cx+iShift);break;
		//PRICE_MEDIAN 4  , (high+low)/2 
		//PRICE_TYPICAL 5  , (high+low+close)/3 
		//PRICE_WEIGHTED 6   , (high+low+close+close)/4 
		}
	}
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void InitChart(double& ayShift[])									// 
{
	if (ArraySize(ayShift)>0) ArrayInitialize(ayShift,EMPTY_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

